# OpalFactoryCodec Class Reference

`#include <opalpluginmgr.h>`

## Public Member Functions

virtual struct PluginCodec_Definition * | GetDefinition ()
virtual PString | GetInputFormat () const =0
virtual PString | GetOutputFormat () const =0
virtual int | Encode (const void *from, unsigned *fromLen, void *to, unsigned *toLen, unsigned int *flag)=0
virtual unsigned int | GetSampleRate () const =0
virtual unsigned int | GetBitsPerSec () const =0
virtual unsigned int | GetFrameTime () const =0
virtual unsigned int | GetSamplesPerFrame () const =0
virtual unsigned int | GetBytesPerFrame () const =0
virtual unsigned int | GetRecommendedFramesPerPacket () const =0
virtual unsigned int | GetMaxFramesPerPacket () const =0
virtual BYTE | GetRTPPayload () const =0
virtual PString | GetSDPFormat () const =0

## Detailed Description

Class for codcs which is accessible via the abstract factory functions. The code would be :

PFactory<OpalFactoryCodec>::CreateInstance(conversion);

to create an instance, where conversion is (eg) "L16:G.711-uLaw-64k"

## Member Function Documentation

virtual int OpalFactoryCodec::Encode | ( | const void * | from,
|  | unsigned * | fromLen,
|  | void * | to,
|  | unsigned * | toLen,
|  | unsigned int * | flag |
| ) |  |  | `[pure virtual]`

Take the supplied data and apply the conversion specified by CreateInstance call (above). When this method returns, toLen contains the number of bytes placed in the destination buffer.

Parameters:

  from | pointer to the source data
  fromLen | number of bytes in the source data to process
  to | pointer to the destination buffer, which contains the output of the conversion
  toLen | Number of available bytes in the destination buffer
  flag | Typically, this is not used.

virtual unsigned int OpalFactoryCodec::GetBitsPerSec | ( |  | ) | const`[pure virtual]`

Return the bitsPerSec field of PluginCodec_Definition for this codec

virtual unsigned int OpalFactoryCodec::GetBytesPerFrame | ( |  | ) | const`[pure virtual]`

Return the bytesPerFrame field of PluginCodec_Definition for this codec

virtual struct PluginCodec_Definition* OpalFactoryCodec::GetDefinition | ( |  | ) | `[inline, virtual]`

Return the PluginCodec_Definition, which describes this codec

virtual unsigned int OpalFactoryCodec::GetFrameTime | ( |  | ) | const`[pure virtual]`

Return the nmPerFrame field of PluginCodec_Definition for this codec

virtual PString OpalFactoryCodec::GetInputFormat | ( |  | ) | const`[pure virtual]`

Return the sourceFormat field of PluginCodec_Definition for this codec

virtual unsigned int OpalFactoryCodec::GetMaxFramesPerPacket | ( |  | ) | const`[pure virtual]`

Return the maxFramesPerPacket field of PluginCodec_Definition for this codec

virtual PString OpalFactoryCodec::GetOutputFormat | ( |  | ) | const`[pure virtual]`

Return the destFormat field of PluginCodec_Definition for this codec

virtual unsigned int OpalFactoryCodec::GetRecommendedFramesPerPacket | ( |  | ) | const`[pure virtual]`

Return the recommendedFramesPerPacket field of PluginCodec_Definition for this codec

virtual BYTE OpalFactoryCodec::GetRTPPayload | ( |  | ) | const`[pure virtual]`

Return the rtpPayload field of PluginCodec_Definition for this codec

virtual unsigned int OpalFactoryCodec::GetSampleRate | ( |  | ) | const`[pure virtual]`

Return the sampleRate field of PluginCodec_Definition for this codec

virtual unsigned int OpalFactoryCodec::GetSamplesPerFrame | ( |  | ) | const`[pure virtual]`

Return the samplesPerFrame field of PluginCodec_Definition for this codec

virtual PString OpalFactoryCodec::GetSDPFormat | ( |  | ) | const`[pure virtual]`

Return the sampleRate field of PluginCodec_Definition for this codec

The documentation for this class was generated from the following file:

- opalpluginmgr.h